package router

import (
	"encoding/json"

	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/server/users"

	"github.com/labstack/echo/v4"
)

const (
	msgInsufficientCaps = "permission denied: insufficient capabilities"
)

// func jsonMsg(msg string) map[string]interface{} {
//     // The following 2 lines are identical:
//     //return map[string]interface{}{"message": msg}
//     return echo.Map{"message": msg}
// }

// Decodes and validates a json object in the response's body.
func decodeJson(c echo.Context, object any) error {
	decoder := json.NewDecoder(c.Request().Body)
	decoder.DisallowUnknownFields()
	return decoder.Decode(object)
}

func getLoggedUser(users *users.Users, c echo.Context) (*users.User, error) {
	// Retrieves user email from context.
	email, err := GetUserFromContext(c)
	if err != nil {
		log.Error("Failed retrieving user info from context: " + err.Error())
		return nil, err
	}
	// Retrieves the user structure
	user, err := users.GetUserByEmail(email)
	if err != nil {
		log.Error("No user matching email " + email + ": " + err.Error())
		return nil, err
	}
	return &user, nil
}
