package users

import (
	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/common/caps"
	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/common/params"

	"github.com/go-playground/validator/v10"
)

type User params.UserWithPwd

var dummyUser = User{}

// Creates an empty user.
func NewEmptyUser() *User {
	return &User{Email: "", FirstName: "", LastName: "", Caps: make(caps.UserCapabilities), Pwd: ""}
}

// Checks that the User structure's fields are valid.
func (user *User) Validate() error {
	// Checks the capabilities are valid
	if err := user.Caps.Validate(); err != nil {
		return err
	}

	return validator.New(validator.WithRequiredStructEnabled()).Struct(user)
}

// Returns true if user has the specified capability.
func (user *User) HasCapability(capability caps.UserCapability) bool {
	_, exists := user.Caps[capability]
	return exists
}
